OpenTTD: NWidgetCore Class Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
NWidgetCore Class Reference
Hierarchical widgets

Base class for a 'real' widget. More...

`#include <widget_type.h>`

Inheritance diagram for NWidgetCore:

## Public Member Functions
| NWidgetCore (WidgetType tp, Colours colour, uint fill_x, uint fill_y, uint32 widget_data, StringID tool_tip)
| Initialization of a 'real' widget.
void | SetIndex (int index)
| Set index of the nested widget in the widget array.
void | SetDataTip (uint32 widget_data, StringID tool_tip)
| Set data and tool tip of the nested widget.
void | SetLowered (bool lowered)
| Lower or raise the widget.
bool | IsLowered () const
| Return whether the widget is lowered.
void | SetDisabled (bool disabled)
| Disable (grey-out) or enable the widget.
bool | IsDisabled () const
| Return whether the widget is disabled.
void | FillNestedArray (NWidgetBase **array, uint length)
NWidgetCore * | GetWidgetFromPos (int x, int y)
| Retrieve a widget by its position.
bool | IsHighlighted () const
| Return whether the widget is highlighted.
TextColour | GetHighlightColour () const
| Return the colour of the highlight.
void | SetHighlighted (TextColour highlight_colour)
| Highlight the widget or not.
Public Member Functions inherited from NWidgetResizeBase
| NWidgetResizeBase (WidgetType tp, uint fill_x, uint fill_y)
| Constructor for resizable nested widgets.
void | SetMinimalSize (uint min_x, uint min_y)
| Set minimal size of the widget.
void | SetMinimalTextLines (uint8 min_lines, uint8 spacing, FontSize size)
| Set minimal text lines for the widget.
void | SetFill (uint fill_x, uint fill_y)
| Set the filling of the widget from initial size.
void | SetResize (uint resize_x, uint resize_y)
| Set resize step of the widget.
void | AssignSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height, bool rtl)
| Assign size and position to the widget.
Public Member Functions inherited from NWidgetBase
| NWidgetBase (WidgetType tp)
| Base class constructor.
virtual void | SetupSmallestSize (Window *w, bool init_array)=0
| Compute smallest size needed by the widget.
virtual NWidgetBase * | GetWidgetOfType (WidgetType tp)
| Retrieve a widget by its type.
void | SetPadding (uint8 top, uint8 right, uint8 bottom, uint8 left)
| Set additional space (padding) around the widget.
uint | GetHorizontalStepSize (SizingType sizing) const
| Get the horizontal sizing step.
uint | GetVerticalStepSize (SizingType sizing) const
| Get the vertical sizing step.
virtual void | Draw (const Window *w)=0
| Draw the widgets of the tree.
virtual void | SetDirty (const Window *w) const
| Mark the widget as 'dirty' (in need of repaint).
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Data Fields
NWidgetDisplay | disp_flags
| Flags that affect display and interaction with the widget.
Colours | colour
| Colour of this widget.
int | index
| Index of the nested widget in the widget array of the window (`-1` means 'not used').
uint32 | widget_data
| Data of the widget.
StringID | tool_tip
| Tooltip of the widget.
int | scrollbar_index
| Index of an attached scrollbar.
TextColour | highlight_colour
| Colour of highlight.
Data Fields inherited from NWidgetResizeBase
uint | min_x
| Minimal horizontal size of only this widget.
uint | min_y
| Minimal vertical size of only this widget.
Data Fields inherited from NWidgetBase
WidgetType | type
| Type of the widget / nested widget.
uint | fill_x
| Horizontal fill stepsize (from initial size, `0` means not resizable).
uint | fill_y
| Vertical fill stepsize (from initial size, `0` means not resizable).
uint | resize_x
| Horizontal resize step (`0` means not resizable).
uint | resize_y
| Vertical resize step (`0` means not resizable).
uint | smallest_x
| Smallest horizontal size of the widget in a filled window.
uint | smallest_y
| Smallest vertical size of the widget in a filled window.
uint | current_x
| Current horizontal size (after resizing).
uint | current_y
| Current vertical size (after resizing).
uint | pos_x
| Horizontal position of top-left corner of the widget in the window.
uint | pos_y
| Vertical position of top-left corner of the widget in the window.
NWidgetBase * | next
| Pointer to next widget in container. Managed by parent container widget.
NWidgetBase * | prev
| Pointer to previous widget in container. Managed by parent container widget.
uint8 | padding_top
| Paddings added to the top of the widget. Managed by parent container widget.
uint8 | padding_right
| Paddings added to the right of the widget. Managed by parent container widget. (parent container may swap this with padding_left for RTL)
uint8 | padding_bottom
| Paddings added to the bottom of the widget. Managed by parent container widget.
uint8 | padding_left
| Paddings added to the left of the widget. Managed by parent container widget. (parent container may swap this with padding_right for RTL)

## Additional Inherited Members
Protected Member Functions inherited from NWidgetBase
void | StoreSizePosition (SizingType sizing, uint x, uint y, uint given_width, uint given_height)
| Store size and position.

## Detailed Description

Base class for a 'real' widget.

Definition at line 284 of file widget_type.h.

## Constructor & Destructor Documentation

NWidgetCore::NWidgetCore | ( | WidgetType | tp,
|  | Colours | colour,
|  | uint | fill_x,
|  | uint | fill_y,
|  | uint32 | widget_data,
|  | StringID | tool_tip
| ) |  |

Initialization of a 'real' widget.

Parameters

  tp | Type of the widget.
  colour | Colour of the widget.
  fill_x | Default horizontal filling.
  fill_y | Default vertical filling.
  widget_data | Data component of the widget.

See Also
  Widget::data

Parameters

  tool_tip | Tool tip of the widget.

See Also
  Widget::tooltips

Definition at line 869 of file widget.cpp.

References colour, index, scrollbar_index, tool_tip, and widget_data.

## Member Function Documentation

TextColour NWidgetCore::GetHighlightColour | ( |  | ) | const
| inlinevirtual

Return the colour of the highlight.

Reimplemented from NWidgetBase.

Definition at line 328 of file widget_type.h.

References highlight_colour.

NWidgetCore * NWidgetCore::GetWidgetFromPos | ( | int | x,
|  | int | y
| ) |  |
| virtual

Retrieve a widget by its position.

Parameters

  x | Horizontal position relative to the left edge of the window.
  y | Vertical position relative to the top edge of the window.

Returns
  Returns the deepest nested widget that covers the given position, or `NULL` if no widget can be found.

Implements NWidgetBase.

Reimplemented in NWidgetBackground.

Definition at line 904 of file widget.cpp.

References NWidgetBase::current_x, NWidgetBase::current_y, IsInsideBS(), NWidgetBase::pos_x, and NWidgetBase::pos_y.

Referenced by NWidgetServerListHeader::GetWidgetFromPos(), NWidgetStacked::GetWidgetFromPos(), NWidgetPIPContainer::GetWidgetFromPos(), NWidgetMatrix::GetWidgetFromPos(), NWidgetToolbarContainer::GetWidgetFromPos(), NWidgetSmallmapDisplay::GetWidgetFromPos(), and NWidgetNewGRFDisplay::GetWidgetFromPos().

bool NWidgetCore::IsDisabled | ( |  | ) | const
| inline

Return whether the widget is disabled.

Definition at line 358 of file widget_type.h.

References disp_flags, HasBit(), and NDB_DISABLED.

Referenced by DispatchLeftClickEvent(), NWidgetBackground::Draw(), NWidgetScrollbar::Draw(), NWidgetLeaf::Draw(), SelectCompanyManagerFaceWindow::DrawFaceStringLabel(), Window::OnHotkey(), and AIDebugWindow::OnPaint().

bool NWidgetCore::IsHighlighted | ( |  | ) | const
| inlinevirtual

Return whether the widget is highlighted.

Reimplemented from NWidgetBase.

Definition at line 322 of file widget_type.h.

References disp_flags, HasBit(), and NDB_HIGHLIGHT.

bool NWidgetCore::IsLowered | ( |  | ) | const
| inline

Return whether the widget is lowered.

Definition at line 343 of file widget_type.h.

References disp_flags, HasBit(), and NDB_LOWERED.

Referenced by NWidgetLeaf::Draw(), and SelectCompanyManagerFaceWindow::DrawFaceStringLabel().

void NWidgetCore::SetDataTip | ( | uint32 | widget_data,
|  | StringID | tool_tip
| ) |  |

Set data and tool tip of the nested widget.

Parameters

  widget_data | Data to use.
  tool_tip | Tool tip string to use.

Definition at line 893 of file widget.cpp.

References tool_tip, and widget_data.

Referenced by CargoWidgets(), MakeCompanyButtonRows(), MakeNWidgetCompanyLines(), MakePerformanceDetailPanels(), NWidgetLeaf::NWidgetLeaf(), StationViewWindow::OnClick(), SelectCompanyManagerFaceWindow::SelectDisplayPlanes(), and NWidgetScrollbar::SetupSmallestSize().

void NWidgetCore::SetDisabled | ( | bool | disabled | ) |
| inline

Disable (grey-out) or enable the widget.

Parameters

  disabled | Widget must be disabled.

Definition at line 352 of file widget_type.h.

References CLRBITS, disp_flags, ND_DISABLED, and SETBITS.

void NWidgetCore::SetHighlighted | ( | TextColour | highlight_colour | ) |
| inlinevirtual

Highlight the widget or not.

Parameters

  highlight_colour | Widget must be highlighted (blink).

Reimplemented from NWidgetBase.

Definition at line 315 of file widget_type.h.

References CLRBITS, disp_flags, highlight_colour, ND_HIGHLIGHT, and SETBITS.

void NWidgetCore::SetIndex | ( | int | index | ) |

Set index of the nested widget in the widget array.

Parameters

  index | Index to use.

Definition at line 882 of file widget.cpp.

References index.

Referenced by NWidgetBackground::NWidgetBackground(), NWidgetLeaf::NWidgetLeaf(), and NWidgetScrollbar::NWidgetScrollbar().

void NWidgetCore::SetLowered | ( | bool | lowered | ) |
| inline

Lower or raise the widget.

Parameters

  lowered | Widget must be lowered (drawn pressed down).

Definition at line 337 of file widget_type.h.

References CLRBITS, disp_flags, ND_LOWERED, and SETBITS.

Referenced by DispatchLeftClickEvent(), NWidgetMatrix::Draw(), MakeCargoButtons(), and Window::RaiseButtons().

## Field Documentation

StringID NWidgetCore::tool_tip

Tooltip of the widget.

See Also
  Widget::tootips

Definition at line 306 of file widget_type.h.

Referenced by DispatchHoverEvent(), DispatchRightClickEvent(), MakeCargoButtons(), MakeNWidget(), NWidgetCore(), and SetDataTip().

uint32 NWidgetCore::widget_data

Data of the widget.

See Also
  Widget::data

Definition at line 305 of file widget_type.h.

Referenced by NWidgetBackground::Draw(), NWidgetLeaf::Draw(), MakeNWidget(), NWidgetCore(), VehicleGroupWindow::OnPaint(), SetDataTip(), BuildRailToolbarWindow::SetupRailToolbar(), NWidgetBackground::SetupSmallestSize(), NWidgetLeaf::SetupSmallestSize(), and ReplaceVehicleWindow::UpdateWidgetSize().

The documentation for this class was generated from the following files:

- src/widget_type.h
- src/widget.cpp